import numpy as np
from random import random 

# Fonction densite k(x) :
#  - Entree : x (reel), choix (entier)
#  - Sortie : A (matrice), b (vecteur)
def k(x, choix):
    if (choix == 1):
        return 10.0
    if (choix == 2):
        return 10*(1.0 + (x*(1-x) - 1./6.0)*4)
    if (choix == 3):
        return 10.0 - 9.0*np.abs(np.sin(20*np.pi*x))
    return 10.0   
    
# Fonction source f(x) :
#  - Entree : x (reel), choix (entier)
#  - Sortie : A (matrice), b (vecteur)
def f(x,choix):
    if (choix == 1):
        return np.cos(2*np.pi*x) + np.sin(4*np.pi*x) 
    if (choix == 2):
        return np.exp(-(x-0.2)*(x-0.2)*200)*5+np.exp(-(x-0.65)*(x-0.65)*100)       
         
            
# Generation donnee pour le cable :
#  - Entree : n (entier), choix (entier)
#  - Sortie : A (matrice), b (vecteur)
def donneeCable(n, choix):
    A = np.zeros((n,n))
    b = np.zeros(n)
    u0 = 1.0
    u1 = 0.0
    
    for l in range(n):
        x = (l+1.0) / (n+1)
        # Completer ICI :
        #A[l,l] = ...
        if (l == 0):
            # Completer ICI :
            #A[0,1] = ...
            #b[0] = ...
        if (l == n-1):
            # Completer ICI :
            #A[n-1,n-2] = ...
            #b[n-1] = ...
            
        if (l>0 and l<n-1):
            # Completer ICI :
            #A[l,l-1] = ...
            #A[l,l+1] = ...
            
    return [A,b]
    
    
    
# Generation donnee pour Helmholtz :
#  - Entree : n (entier), omega (reel)
#  - Sortie : A (matrice), b (vecteur)
def donneeHelmholtz(n, omega, choix):
    A = np.zeros((n+1,n+1))
    b = np.zeros(n+1)
    for l in range(n+1):
        x = (l*1.0) / (n+1.0)
        b[l] = f(x,choix)
        
        if (l == 0):
            # Completer ICI :
            #A[0,0] = ...
            #A[0,1] = ...
            #A[0,n] = ...
        if (l == n):
            # Completer ICI :
            #A[n,n] = ...
            #A[n,n-1] = ...
            #A[n,0] = ...
        if (l>0 and l<n):
            # Completer ICI :
            #A[l,l] = ...
            #A[l,l-1] = ...
            #A[l,l+1] = ...
    return [A,b]  
    


# Generation donnee pour Helmholtz :
#  - Entree : n (entier), omega (reel)
#  - Sortie : A (matrice), b (vecteur)
def donneePbInverse(N,choix):
    mesures = np.loadtxt("mesures1.data")
    if (choix == 2):
        mesures = np.loadtxt("mesures2.data")
        
    m = len(mesures[:,0])
    xx = mesures[:,0]
    y = mesures[:,1]
    
    A = np.zeros((m,2*N+1))
    b = np.zeros(m)
    
    for l in range(m):
        x = xx[l]
        
        # Completer ICI :
        #b[l] = ...
        
        for c in range(N+1):
            # Completer ICI :
            #A[l,c] = ...
        for c in range(N):
            # Completer ICI :
            #A[l,c+N+1] = ...
        
    return [A,b]  
