import numpy as np
import matplotlib.pyplot as plt

import algo
import data
import affichage




"""
    Histoire de cable
"""

########################################
# Parametres discretisation
########################################

n = 500
tol = 1e-8
iteMax = 1000
affich = 1

########################################
# Recuperation des donnees
########################################

print "Choix de la fonction densite k(x) :"
print "1 : constante"
print "2 : polynomiale"
print "3 : periodique"
choix = input()


[A,b] = data.donneeCable(n, choix)

print "Choix de la methode de resolution :"
print "1 : cholesky"
print "2 : descente gradient"
print "3 : CG"
method = input()


########################################
# Resolution effective du probleme
########################################

u = b*0;
if (method == 1):
    G = algo.cholesky(A)
    y = algo.descente(G,b)
    u = algo.remontee(G.transpose(),y)

if (method == 2):
    [u,residus] = algo.gradient(A,b,b*0,tol,iteMax,n,affich)


if (method == 3):
    [u,residus] = algo.CG(A,b,b*0,tol,iteMax,n,affich)

########################################
# Affichage de la solution
########################################


affichage.afficher([np.arange(0.0,n)/(n)],[u])


print "FIN \n"
########################################




